Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 3211)
@@ -29,4 +29,9 @@
 
    LOGICAL :: l_trd  ! flag to compute trends or not
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -78,4 +83,8 @@
       USE wrk_nemo, ONLY:   zltu => wrk_3d_3 , zltv => wrk_3d_4   !  -      -
       USE wrk_nemo, ONLY:   zti  => wrk_3d_5 , ztw  => wrk_3d_6   !  -      -
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx zwy ztu ztv zltu zltv zti ztw :I :I :z
+
       !
       INTEGER                              , INTENT(in   ) ::   kt              ! ocean time-step index
@@ -83,7 +92,21 @@
       INTEGER                              , INTENT(in   ) ::   kjpt            ! number of tracers
       REAL(wp), DIMENSION(        jpk     ), INTENT(in   ) ::   p2dt            ! vertical profile of tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+!FTRANS pun pvn pwn :I :I :z
+!FTRANS ptb ptn pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   pun(jpi,jpj,jpk)        ! ocean velocity component (u)
+      REAL(wp), INTENT(in   ) ::   pvn(jpi,jpj,jpk)        ! ocean velocity component (v)
+      REAL(wp), INTENT(in   ) ::   pwn(jpi,jpj,jpk)        ! ocean velocity component (w)
+!! DCSE_NEMO: Next two arguments made inout to silence the cray compile,
+!! which rightly complains about the call to nonosc_v (which also has them
+!! as inout) 
+      REAL(wp), INTENT(inout) ::   ptb(jpi,jpj,jpk,kjpt)   ! tracer fields (before)
+      REAL(wp), INTENT(inout) ::   ptn(jpi,jpj,jpk,kjpt)   ! tracer fields (now)
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)   ! tracer trend 
+
       !
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -113,4 +136,9 @@
          zltu(:,:,jpk) = 0.e0       ;      zltv(:,:,jpk) = 0.e0
          !                                              
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                                 ! Horizontal slab
             !                                   
@@ -118,4 +146,5 @@
             DO jj = 1, jpjm1            ! First derivative (gradient)
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   zeeu = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
                   zeev = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
@@ -124,6 +153,13 @@
                END DO
             END DO
+#if defined key_z_first
+         END DO
+         DO jj = 2, jpjm1               ! Second derivative (divergence)
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
             DO jj = 2, jpjm1            ! Second derivative (divergence)
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zcoef = 1. / ( 6. * fse3t(ji,jj,jk) )
                   zltu(ji,jj,jk) = (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)  ) * zcoef
@@ -137,7 +173,13 @@
          !    
          !  Horizontal advective fluxes               
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1                                 ! Horizontal slab
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   ! upstream transport
                   zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )
@@ -158,8 +200,14 @@
 
          ! Horizontal advective trends
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             !  Tracer flux divergence at t-point added to the general trend
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! horizontal advective
@@ -203,7 +251,13 @@
          ! -------------------------------------------------------------------
          ! Interior value
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                    zfp_wk = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
                    zfm_wk = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
@@ -213,8 +267,15 @@
          END DO 
          ! update and guess with monotonic sheme
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+                  z2dtt = p2dt(jk)
+#else
          DO jk = 1, jpkm1
             z2dtt = p2dt(jk)
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ztak = - ( ztw(ji,jj,jk) - ztw(ji,jj,jk+1) ) * zbtr
@@ -228,8 +289,15 @@
 
          !  antidiffusive flux : high order minus low order
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztw(ji,jj,1) = 0.e0   ! Surface value
+               DO jk = 2, jpkm1      ! Interior value
+#else
          ztw(:,:,1) = 0.e0       ! Surface value
          DO jk = 2, jpkm1        ! Interior value
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   ztw(ji,jj,jk) = 0.5 * pwn(ji,jj,jk) * ( ptn(ji,jj,jk,jn) + ptn(ji,jj,jk-1,jn) ) - ztw(ji,jj,jk)
                END DO
@@ -240,7 +308,13 @@
 
          !  final trend with corrected fluxes
+#if defined key_z_first
+         DO jj = 2, jpjm1 
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1 
                DO ji = fs_2, fs_jpim1   ! vector opt.   
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                   ! k- vertical advective trends  
@@ -254,7 +328,14 @@
          !  Save the final vertical advective trends
          IF( l_trd )  THEN                        ! vertical advective trend diagnostics
-            DO jk = 1, jpkm1                       ! (compute -w.dk[ptn]= -dk[w.ptn] + ptn.dk[w])
+            ! (compute -w.dk[ptn]= -dk[w.ptn] + ptn.dk[w])
+#if defined key_z_first
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  DO jk = 1, jpkm1
+#else
+            DO jk = 1, jpkm1
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                      zbtr = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
                      z_hdivn = (  pwn(ji,jj,jk) - pwn(ji,jj,jk+1)  ) * zbtr
@@ -270,4 +351,11 @@
       IF( wrk_not_released(3, 1,2,3,4,5,6) )   CALL ctl_stop('tra_adv_ubs: failed to release workspace arrays')
       !
+
+      !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+
    END SUBROUTINE tra_adv_ubs
 
@@ -288,9 +376,20 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zbetup => wrk_3d_1, zbetdo => wrk_3d_2   ! 3D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zbetup zbetdo :I :I :z
+
       !
       REAL(wp), INTENT(in   ), DIMENSION(jpk)          ::   p2dt   ! vertical profile of tracer time-step
-      REAL(wp),                DIMENSION (jpi,jpj,jpk) ::   pbef   ! before field
-      REAL(wp), INTENT(inout), DIMENSION (jpi,jpj,jpk) ::   paft   ! after field
-      REAL(wp), INTENT(inout), DIMENSION (jpi,jpj,jpk) ::   pcc    ! monotonic flux in the k direction
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp),                DIMENSION (jpi,jpj,jpk) ::   pbef   ! before field
+!     REAL(wp), INTENT(inout), DIMENSION (jpi,jpj,jpk) ::   paft   ! after field
+!     REAL(wp), INTENT(inout), DIMENSION (jpi,jpj,jpk) ::   pcc    ! monotonic flux in the k direction
+
+!FTRANS pbef paft pcc :I :I :z
+      REAL(wp), INTENT(inout) ::   pbef(jpi,jpj,jpk)   ! before field
+      REAL(wp), INTENT(inout) ::   paft(jpi,jpj,jpk)   ! after field
+      REAL(wp), INTENT(inout) ::   pcc(jpi,jpj,jpk)    ! monotonic flux in the k direction
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -313,8 +412,15 @@
       paft(:,:,:) = paft(:,:,:) * tmask(:,:,:) - zbig * ( 1.e0 - tmask(:,:,:) )
       ! search maximum in neighbourhood
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+               ikm1 = MAX(jk-1,1)
+#else
       DO jk = 1, jpkm1
          ikm1 = MAX(jk-1,1)
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zbetup(ji,jj,jk) = MAX(  pbef(ji  ,jj  ,jk  ), paft(ji  ,jj  ,jk  ),   &
                   &                     pbef(ji  ,jj  ,ikm1), pbef(ji  ,jj  ,jk+1),   &
@@ -327,8 +433,15 @@
       paft(:,:,:) = paft(:,:,:) * tmask(:,:,:) + zbig * ( 1.e0 - tmask(:,:,:) )
       ! search minimum in neighbourhood
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+               ikm1 = MAX(jk-1,1)
+#else
       DO jk = 1, jpkm1
          ikm1 = MAX(jk-1,1)
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zbetdo(ji,jj,jk) = MIN(  pbef(ji  ,jj  ,jk  ), paft(ji  ,jj  ,jk  ),   &
                   &                     pbef(ji  ,jj  ,ikm1), pbef(ji  ,jj  ,jk+1),   &
@@ -346,8 +459,15 @@
       ! ------------------------------------------------------
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+               z2dtt = p2dt(jk)
+#else
       DO jk = 1, jpkm1
          z2dtt = p2dt(jk)
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ! positive & negative part of the flux
                zpos = MAX( 0., pcc(ji  ,jj  ,jk+1) ) - MIN( 0., pcc(ji  ,jj  ,jk  ) )
@@ -362,7 +482,13 @@
       ! monotonic flux in the k direction, i.e. pcc
       ! -------------------------------------------
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                za = MIN( 1., zbetdo(ji,jj,jk), zbetup(ji,jj,jk-1) )
                zb = MIN( 1., zbetup(ji,jj,jk), zbetdo(ji,jj,jk-1) )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 3211)
@@ -35,4 +35,8 @@
 
    REAL(wp), PUBLIC, DIMENSION(:,:), ALLOCATABLE ::   qgh_trd0   ! geothermal heating trend
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
  
    !! * Substitutions
@@ -71,4 +75,6 @@
       INTEGER  ::   ji, jj, ik    ! dummy loop indices
       REAL(wp) ::   zqgh_trd      ! geothermal heat flux trend
+
+!FTRANS ztrdt :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt
       !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 3211)
@@ -65,4 +65,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   r1_e1e2t               ! inverse of the cell surface at t-point      [1/m2]
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -105,4 +109,6 @@
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
+
+!FTRANS ztrdt ztrds :I :I :z
 
       IF( l_trdtra )   THEN                    !* Save ta and sa trends
@@ -146,4 +152,8 @@
    END SUBROUTINE tra_bbl
 
+      !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    SUBROUTINE tra_bbl_dif( ptb, pta, kjpt )
@@ -173,6 +183,11 @@
       !
       INTEGER                              , INTENT(in   ) ::   kjpt   ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb    ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta    ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb    ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta    ! tracer trend 
+!FTRANS ptb pta :I :I :z :I
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)    ! before tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)    ! tracer trend 
       !
       INTEGER  ::   ji, jj, jn   ! dummy loop indices
@@ -220,6 +235,11 @@
       IF( wrk_not_released(2,1) )   CALL ctl_stop('tra_bbl_dif: failed to release workspace array')
       !
+
    END SUBROUTINE tra_bbl_dif
-   
+
+      !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    SUBROUTINE tra_bbl_adv( ptb, pta, kjpt )
@@ -239,6 +259,11 @@
       !!----------------------------------------------------------------------  
       INTEGER                              , INTENT(in   ) ::   kjpt   ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb    ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta    ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb    ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta    ! tracer trend 
+!FTRANS ptb pta :I :I :z :I
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)    ! before tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)    ! tracer trend 
       !
       INTEGER  ::   ji, jj, jk, jn           ! dummy loop indices
@@ -310,4 +335,8 @@
    END SUBROUTINE tra_bbl_adv
 
+      !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    SUBROUTINE bbl( kt, cdtype )
@@ -608,6 +637,11 @@
 
       !                             !* masked diffusive flux coefficients 
+#if defined key_z_first
+      ahu_bbl_0(:,:) = rn_ahtbbl * e2u(:,:) * e3u_bbl_0(:,:) / e1u(:,:)  * umask_1(:,:)
+      ahv_bbl_0(:,:) = rn_ahtbbl * e1v(:,:) * e3v_bbl_0(:,:) / e2v(:,:)  * vmask_1(:,:)
+#else
       ahu_bbl_0(:,:) = rn_ahtbbl * e2u(:,:) * e3u_bbl_0(:,:) / e1u(:,:)  * umask(:,:,1)
       ahv_bbl_0(:,:) = rn_ahtbbl * e1v(:,:) * e3v_bbl_0(:,:) / e2v(:,:)  * vmask(:,:,1)
+#endif
 
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp.F90	(revision 3211)
@@ -64,4 +64,12 @@
    INTEGER  ::   nn_file =    2      ! = 1 create a damping.coeff NetCDF file 
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "dtatem_ftrans.h90"
+#  include "dtasal_ftrans.h90"
+#  include "tradmp_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -112,7 +120,13 @@
       !
       CASE( 0 )                   !==  newtonian damping throughout the water column  ==!
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
                   zsa = resto(ji,jj,jk) * ( s_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_sal) )
@@ -126,7 +140,13 @@
          !
       CASE ( 1 )                  !==  no damping in the turbocline (avt > 5 cm2/s)  ==!
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   IF( avt(ji,jj,jk) <= 5.e-4_wp ) THEN
                      zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
@@ -145,7 +165,13 @@
          !
       CASE ( 2 )                  !==  no damping in the mixed layer   ==!
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   IF( fsdept(ji,jj,jk) >= hmlp (ji,jj) ) THEN
                      zta = resto(ji,jj,jk) * ( t_dta(ji,jj,jk) - tsb(ji,jj,jk,jp_tem) )
@@ -252,5 +278,9 @@
       !! ** Action  : - resto, the damping coeff. for T and S
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::   presto   ! restoring coeff. (s-1)
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::   presto   ! restoring coeff. (s-1)
+!FTRANS presto :I :I :z
+      REAL(wp), INTENT(inout)  ::   presto(jpi,jpj,jpk)   ! restoring coeff. (s-1)
       !
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -292,7 +322,13 @@
          z1_5d = 1._wp / ( 5._wp * rday )   ! z1_5d : 1 / 5days
 
+#if defined key_z_first
+         DO jj = 1, jpj             ! Compute arrays resto ; value for internal damping : 5 days
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1           ! Compute arrays resto ; value for internal damping : 5 days
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zlat = ABS( gphit(ji,jj) )
                   IF( zlat1 <= zlat .AND. zlat <= zlat2 ) THEN
@@ -311,4 +347,12 @@
    END SUBROUTINE dtacof_zoom
 
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "dtatem_ftrans.h90"
+#  include "dtasal_ftrans.h90"
+#  include "tradmp_ftrans.h90"
 
    SUBROUTINE dtacof( kn_hdmp, pn_surf, pn_bot, pn_dep,  &
@@ -329,4 +373,8 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zhfac => wrk_1d_1, zmrs => wrk_2d_1 , zdct  => wrk_3d_1   ! 1D, 2D, 3D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zdct :I :I :z
+
       !!
       INTEGER                         , INTENT(in   )  ::  kn_hdmp    ! damping option
@@ -336,5 +384,10 @@
       INTEGER                         , INTENT(in   )  ::  kn_file    ! save the damping coef on a file or not
       CHARACTER(len=3)                , INTENT(in   )  ::  cdtype     ! =TRA or TRC (tracer indicator)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::  presto     ! restoring coeff. (s-1)
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout)  ::   presto   ! restoring coeff. (s-1)
+!FTRANS presto :I :I :z
+      REAL(wp), INTENT(inout)  ::   presto(jpi,jpj,jpk)   ! restoring coeff. (s-1)
+
       !
       INTEGER  ::   ji, jj, jk                  ! dummy loop indices
@@ -407,7 +460,13 @@
          zsdmp = 1._wp / ( pn_surf * rday )
          zbdmp = 1._wp / ( pn_bot  * rday )
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zdct(ji,jj,jk) = MIN( zinfl, zdct(ji,jj,jk) )
                   !   ... Decrease the value in the vicinity of the coast
@@ -518,7 +577,17 @@
          END SELECT
 
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  presto(ji,jj,jk) = zmrs(ji,jj) * zhfac(jk) + ( 1._wp - zmrs(ji,jj) ) * presto(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             presto(:,:,jk) = zmrs(:,:) * zhfac(jk) + ( 1._wp - zmrs(:,:) ) * presto(:,:,jk)
          END DO
+#endif
 
          ! Mask resto array and set to 0 first and last levels
@@ -550,4 +619,12 @@
    END SUBROUTINE dtacof
 
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "dtatem_ftrans.h90"
+#  include "dtasal_ftrans.h90"
+#  include "tradmp_ftrans.h90"
 
    SUBROUTINE cofdis( pdct )
@@ -571,9 +648,14 @@
       !!              - NetCDF file 'dist.coast.nc' 
       !!----------------------------------------------------------------------
-      USE ioipsl      ! IOipsl librairy
+      USE ioipsl      ! IOipsl library
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zxt => wrk_2d_1 , zyt => wrk_2d_2 , zzt => wrk_2d_3, zmask => wrk_2d_4
       !!
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( out ) ::   pdct   ! distance to the coastline
+!FTRANS pdct :I :I :z
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( out ) ::   pdct   ! distance to the coastline
+
       !!
       INTEGER ::   ji, jj, jk, jl   ! dummy loop indices
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/tradmp_ftrans.h90	(revision 3211)
@@ -0,0 +1,22 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  tradmp_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices for
+   !!   public multi-dimensional arrays with a z-dimension declared in
+   !!   module tradmp.  It should be included wherever the module is used,
+   !!   and updated whenever a new public array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS strdmp :I :I :z
+!FTRANS ttrdmp :I :I :z
+!FTRANS resto :I :I :z
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf.F90	(revision 3211)
@@ -21,5 +21,8 @@
    USE traldf_bilap    ! lateral mixing             (tra_ldf_bilap routine)
    USE traldf_iso      ! lateral mixing               (tra_ldf_iso routine)
-   USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
+
+!! DCSE_NEMO
+!  USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
+   USE traldf_iso_grif, ONLY : tra_ldf_iso_grif ! lateral mixing
    USE traldf_lap      ! lateral mixing               (tra_ldf_lap routine)
    USE trdmod_oce      ! ocean space and time domain
@@ -41,4 +44,12 @@
    !                                                               !  (key_traldf_ano only)
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+!FTRANS t0_ldf s0_ldf :I :I :z
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -59,4 +70,5 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
+!FTRANS ztrdt ztrds :I :I :z
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
@@ -115,4 +127,12 @@
    END SUBROUTINE tra_ldf
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+!FTRANS t0_ldf s0_ldf :I :I :z
 
    SUBROUTINE tra_ldf_init
@@ -240,10 +260,21 @@
       USE wrk_nemo, ONLY:   zt_ref => wrk_3d_1, ztb => wrk_3d_2, zavt => wrk_3d_3   ! 3D workspaces
       USE wrk_nemo, ONLY:   zs_ref => wrk_3d_4, zsb => wrk_3d_5                     ! 3D workspaces
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zt_ref ztb zavt zs_ref zsb :I :I :z
       !
       USE zdf_oce         ! vertical mixing
       USE trazdf          ! vertical mixing: double diffusion
       USE zdfddm          ! vertical mixing: double diffusion
-      !
+
+#  include "zdf_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
+      !
+#if defined key_z_first
+      INTEGER  ::   ji, jj, jk      ! Dummy loop indices
+#else
       INTEGER  ::   jk              ! Dummy loop indice
+#endif
       INTEGER  ::   ierr            ! local integer
       LOGICAL  ::   llsave          ! local logical
@@ -309,8 +340,19 @@
          s0_ldf(:,:,:) = tsa(:,:,:,jp_sal)
       ELSE
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  t0_ldf(ji,jj,jk) = ( tsa(ji,jj,jk,jp_tem) - tsb(ji,jj,jk,jp_tem) ) / ( z12 *rdttra(jk) )
+                  s0_ldf(ji,jj,jk) = ( tsa(ji,jj,jk,jp_sal) - tsb(ji,jj,jk,jp_sal) ) / ( z12 *rdttra(jk) )
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             t0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / ( z12 *rdttra(jk) )
             s0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / ( z12 *rdttra(jk) )
          END DO
+#endif
       ENDIF
       tsb(:,:,:,jp_tem) = ztb (:,:,:)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 3211)
@@ -34,4 +34,11 @@
 
    PUBLIC   tra_ldf_bilap   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -77,4 +84,8 @@
       USE oce     , ONLY:   ztu  => ua       , ztv  => va                           ! (ua,va) used as workspace
       USE wrk_nemo, ONLY:   zeeu => wrk_2d_1 , zeev => wrk_2d_2 , zlt => wrk_2d_3   ! 2D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztu ztv :I :I :z
+
       !!
       INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
@@ -82,6 +93,12 @@
       INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
       REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+!FTRANS ptb pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)        ! before tracer fields
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)        ! tracer trend 
+
       !!
       INTEGER  ::  ji, jj, jk, jn   ! dummy loop indices
